
#include "stdafx.h"
#include "CLS_DlgCfgMain.h"
#include "CLS_DlgCfgPicStream.h"
#include "CLS_DlgCfgVcaEvent.h"

extern map<int, CONNECT_STATE> g_mapLogonInfo;


IMPLEMENT_DYNAMIC(CLS_DlgCfgMain, CDialog)

CLS_DlgCfgMain::CLS_DlgCfgMain(CWnd* pParent /*=NULL*/)
	: CLS_CfgBasePage(CLS_DlgCfgMain::IDD, pParent)
{
	for (int i = 0; i < CFG_MAX; i++)
	{
		m_pPage[i] = NULL;
	}
	m_pCurCfgPage = NULL;
	m_pSwallowConfig = NULL;
}

CLS_DlgCfgMain::~CLS_DlgCfgMain()
{
	for (int i = 0; i < CFG_MAX; i++)
	{
		if (NULL != m_pPage)
		{
			delete m_pPage[i];
			m_pPage[i] = NULL;
		}	
	}

	if (NULL != m_pSwallowConfig)
	{
		delete m_pSwallowConfig;
		m_pSwallowConfig = NULL;
	}
}

void CLS_DlgCfgMain::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
//	DDX_Control(pDX, IDC_SWALLOW_CFG_VIDEO, m_swallowCfg);
	DDX_Control(pDX, IDC_TREE_DEVICE, m_treeDevice);
	DDX_Control(pDX, IDC_TREE_CONFIG, m_treeConfig);
}


BEGIN_MESSAGE_MAP(CLS_DlgCfgMain, CDialog)
	ON_WM_SHOWWINDOW()
	ON_NOTIFY(TVN_SELCHANGING, IDC_TREE_CONFIG, &CLS_DlgCfgMain::OnTvnSelchangingTreeConfig)
	ON_NOTIFY(NM_DBLCLK, IDC_TREE_DEVICE, &CLS_DlgCfgMain::OnNMDblclkTreeDevice)
	ON_WM_DESTROY()
END_MESSAGE_MAP()

BEGIN_EVENTSINK_MAP(CLS_DlgCfgMain, CLS_CfgBasePage)
	ON_EVENT(CLS_DlgCfgMain, IDC_SWALLOW_CFG_VIDEO, 39, CLS_DlgCfgMain::OnPicStreamInfoSwallowCfgVideo, VTS_BSTR)
END_EVENTSINK_MAP()

void CLS_DlgCfgMain::OnDestroy()
{
//	Swallow_DisConnectVideo(&m_swallowCfg, m_swallowCfg.GetCurObs());
	CLS_CfgBasePage::OnDestroy();
}

BOOL CLS_DlgCfgMain::OnInitDialog()
{
	CLS_CfgBasePage::OnInitDialog();

	RECT rcShow = {0};
	GetDlgItem(IDD_OCXPLAYDEMO_CONFIG)->GetWindowRect(&rcShow);
	ScreenToClient(&rcShow);
	m_pSwallowConfig = new CSwallow();
	int iRet = m_pSwallowConfig->Create(_T(""),_T(""), WS_CHILDWINDOW, rcShow, this, IDC_SWALLOW_CFG_VIDEO);
	m_pSwallowConfig->ShowWindow(SW_SHOW);
	m_pSwallowConfig->MoveWindow(&rcShow);

	InitDeviceTree();
	InitFunctionTree();
	Swallow_Init(m_pSwallowConfig);
	VARIANT var  = getitovar(0);
	VARIANT var1 = getstovar("");
	VARIANT var2 = getitovar(1);
	VARIANT var3 = getitovar(1);
	m_pSwallowConfig->Commander(Obs_Monopolize_Cmd,var1,var2,var3,var,var,var,var,var,var);
	ShowCfgPage(CFG_MIN);
	return TRUE;
}

int CLS_DlgCfgMain::InitDeviceTree()
{
	HTREEITEM hItem = NULL;
	int iModel = 0;
	map<int, CONNECT_STATE>::iterator it = g_mapLogonInfo.begin();
	if (it == g_mapLogonInfo.end())
	{
		return 0;
	}

	m_iLogonId	= it->first;
	m_iChanNo	= 0;
	m_iStreamNo = 0;

	for (; it != g_mapLogonInfo.end(); it++)
	{
		CONNECT_STATE st = it->second;
		hItem = m_treeDevice.InsertItem(st.m_strIP, TVI_ROOT);
		m_treeDevice.SetItemData(hItem, it->first);
		CString cstrMode;
		Swallow_GetDevModel(m_pSwallowConfig, it->first, &iModel, cstrMode);
		for (int iChanNo = 0; iChanNo < st.m_iTotalChannel; ++iChanNo)
		{
			AddChannelItem(iChanNo, CHANNEL_TYPE_MAINSTREAM, hItem);
			AddChannelItem(iChanNo, CHANNEL_TYPE_SUBSTREAM, hItem);
			//AddChannelItem(iChanNo, CHANNEL_TYPE_THIRDSTREAM, hItem);
		}
	}

	m_treeDevice.Expand(hItem, TVE_EXPAND);

	return 0;
}

int CLS_DlgCfgMain::AddChannelItem(int _iChanNo, int _iChanType, HTREEITEM _hParent)
{
	CString strTitle;
	unsigned int uChannel = 0;
	if (CHANNEL_TYPE_THIRDSTREAM != _iChanType)
	{
		MakeChannel(_iChanNo, _iChanType == 1 ? 1 : 0, &uChannel);
	} 
	else
	{
		MakeChannel(_iChanNo, CHANNEL_THREE_STREAM, &uChannel);
	}

	switch(_iChanType)
	{
	case CHANNEL_TYPE_MAINSTREAM:
		strTitle.Format(_T("CH%d-MAIN"),_iChanNo);
		break;
	case CHANNEL_TYPE_SUBSTREAM:
		strTitle.Format(_T("CH%d-SUB"),_iChanNo);
		break;
	case CHANNEL_TYPE_DIGITAL:
		strTitle.Format(_T("CH%d-DIGITAL"),_iChanNo);
		break;
	case CHANNEL_TYPE_COMBINE:
		strTitle.Format(_T("CH%d-COMBINE"),_iChanNo);
		break;
	case CHANNEL_TYPE_THIRDSTREAM:
		strTitle.Format(_T("CH%d-THIRD"),_iChanNo);
		break;
	default:
		strTitle.Format(_T("CH%d-%d"),_iChanNo, _iChanType);
		break;
	}
	HTREEITEM hItem = m_treeDevice.InsertItem(strTitle, _hParent);
	m_treeDevice.SetItemData(hItem, uChannel);
	return 0;
}

int CLS_DlgCfgMain::MakeChannel( int _iChanNo, int _iStreamNo, unsigned int* _puChannel)
{
	if (NULL == _puChannel)
	{
		return -1;
	}
	*_puChannel = (_iChanNo << 16 | _iStreamNo);
	return 0;
}

int CLS_DlgCfgMain::AnalyzeChannel(unsigned int _uChannel,int* _piChannelNo,int* _piStreamNo)
{
	if (NULL == _piChannelNo || NULL == _piStreamNo || -1 == _uChannel)
	{
		return -1;
	}
	*_piChannelNo = HIWORD(_uChannel);
	*_piStreamNo = LOWORD(_uChannel);
	return 0;
}

int CLS_DlgCfgMain::InitFunctionTree()
{
	HTREEITEM hItem = NULL;
	HTREEITEM hSubItem = NULL;
	m_treeConfig.DeleteAllItems();
	
	//ܷģ
	hItem = m_treeConfig.InsertItem("VCA");
	m_treeConfig.SetItemData(hItem, CFG_VCA_EVENT);

	//ܷ-¼
	hSubItem = m_treeConfig.InsertItem("Events", hItem);	
	m_treeConfig.SetItemData(hSubItem, CFG_VCA_EVENT);

	hSubItem = m_treeConfig.InsertItem("PicStream", hItem);	
	m_treeConfig.SetItemData(hSubItem, CFG_PIC_STREAM);

	m_treeConfig.Expand(hItem, TVE_EXPAND);
	return 0;
}

void CLS_DlgCfgMain::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CLS_CfgBasePage::OnShowWindow(bShow, nStatus);
}

int CLS_DlgCfgMain::ShowCfgPage(int _iIndex)
{
	if (_iIndex < CFG_MIN || _iIndex > CFG_MAX)
	{
		return -1;
	}

	if (NULL == m_pPage[_iIndex])
	{
		switch(_iIndex)
		{
		case CFG_VCA_EVENT:		//ܷ-
			{
				m_pPage[_iIndex] = new CLS_DlgCfgVcaEvent(this);
				m_pPage[_iIndex]->Create(IDD_DLG_CFG_VCA_EVENT, this);
			}
			break;
		case CFG_PIC_STREAM:
			{
				m_pPage[_iIndex] = new CLS_DlgCfgPicStream(this);
				m_pPage[_iIndex]->Create(IDD_DLG_CFG_PIC_STREAM, this);
			}
			break;
		default:
			break;
		}

		if (m_pPage[_iIndex])
		{
			RECT rcShow = {0};
			GetDlgItem(IDC_GBO_CFG_PAGE)->GetWindowRect(&rcShow);
			ScreenToClient(&rcShow);
			m_pPage[_iIndex]->MoveWindow(&rcShow);
			m_pPage[_iIndex]->m_pSwallowCfg = m_pSwallowConfig;
			m_pPage[_iIndex]->m_lObsId = m_pSwallowConfig->GetCurObs();
			m_pPage[_iIndex]->m_iLogonId = m_iLogonId;

		}
		else
		{
			return -1;
		}
	}

	if(m_pCurCfgPage == m_pPage[_iIndex])
	{
		return 0;
	}

	if(m_pCurCfgPage)
	{
		m_pCurCfgPage->ShowWindow(SW_HIDE);
	}
	m_pCurCfgPage = m_pPage[_iIndex];
	m_pCurCfgPage->ShowWindow(SW_SHOW);
	return 0;
}

void CLS_DlgCfgMain::OnNMDblclkTreeDevice(NMHDR *pNMHDR, LRESULT *pResult)
{
	ConnectVideo();
	*pResult = 0;
}

void CLS_DlgCfgMain::OnTvnSelchangingTreeConfig(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);
	if (!pNMTreeView->itemNew.hItem || !pNMTreeView->itemOld.hItem)
	{
		return;
	}

	DWORD dwOldItemData = m_treeConfig.GetItemData(pNMTreeView->itemOld.hItem);
	DWORD dwNewItemData = m_treeConfig.GetItemData(pNMTreeView->itemNew.hItem);
	if (dwOldItemData == dwNewItemData)
	{
		return;
	}

	ShowCfgPage(dwNewItemData);
	*pResult = 0;
}

void CLS_DlgCfgMain::ConnectVideo()
{
	HTREEITEM hItem = m_treeDevice.GetSelectedItem();
	if(NULL == hItem)
	{
		return;
	}

	HTREEITEM hParent = m_treeDevice.GetParentItem(hItem);
	if (NULL == hParent)
	{
		return;
	}

	int iLogonId = m_treeDevice.GetItemData(hParent);
	unsigned int uChannel = m_treeDevice.GetItemData(hItem);
	int iChanNo = -1;
	int iStreamNo = -1;
	AnalyzeChannel(uChannel, &iChanNo, &iStreamNo);

	//ȡǰId
	long lobsID = m_pSwallowConfig->GetCurObs();

	//жǷƵ
	int iState = Swallow_ConnectStatus(m_pSwallowConfig, lobsID);
	if (1 == iState)	//Ƶ
	{
		//жǷ
		if (iLogonId == m_iLogonId && iChanNo == m_iChanNo && iStreamNo == m_iStreamNo)
		{
			return;
		}
		else if (Swallow_DisConnectVideo(m_pSwallowConfig, lobsID) < 0)
		{
			return;
		}
	}

	m_iLogonId = iLogonId;
	m_iChanNo = iChanNo;
	m_iStreamNo = iStreamNo;

	CLIENTINFO stParam = {0};
	stParam.m_iServerID		= m_iLogonId;	//¼Id
	stParam.m_iChannelNo	= m_iChanNo;	//ͨ
	stParam.m_iStreamNO		= m_iStreamNo;	//
	stParam.m_iBufferCount	= 10;			//С
	stParam.m_iDelayNum		= 1;			//֡	
	stParam.m_iNetMode		= 1;			//ģʽ,Ĭ1 TCP
	if(0 > Swallow_ConnectVideo(m_pSwallowConfig, lobsID, stParam))
	{
		CString szRet;
		szRet.Format("[OCXPlayDemoDlg]function failed at %s, line:%d , errno is %d\n",__FILE__, __LINE__, GetLastError());
		OutputDebugString(szRet);
	}
}


void CLS_DlgCfgMain::OnPicStreamInfoSwallowCfgVideo(LPCTSTR _bstrResult)
{
	m_pCurCfgPage->OnPicStreamInfo(_bstrResult);
	return ;// TODO: ڴ˴Ϣ
}
