
#include "stdafx.h"
#include "../OCXPlayDemo.h"
#include "CLS_DlgCfgVcaEvent.h"


IMPLEMENT_DYNAMIC(CLS_DlgCfgVcaEvent, CDialog)

CLS_DlgCfgVcaEvent::CLS_DlgCfgVcaEvent(CWnd* pParent /*=NULL*/)
	: CLS_CfgBasePage(CLS_DlgCfgVcaEvent::IDD, pParent)
{
	m_iDrawColor = DRAW_COLOR_GREEN;
	m_blDrawing = false;
}

CLS_DlgCfgVcaEvent::~CLS_DlgCfgVcaEvent()
{
}

void CLS_DlgCfgVcaEvent::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CBO_VCA_EVENTS, m_cboVcaEvent);
	DDX_Control(pDX, IDC_BTN_VCA_EVENT_COLOR_DISPLAY, m_btnDisplayColor);
}


BEGIN_MESSAGE_MAP(CLS_DlgCfgVcaEvent, CDialog)
	ON_WM_SHOWWINDOW()
	ON_CBN_SELCHANGE(IDC_CBO_VCA_EVENTS, &CLS_DlgCfgVcaEvent::OnCbnSelchangeCboVcaEvents)
	ON_BN_CLICKED(IDC_BTN_VCA_EVENT_DRAW_START, &CLS_DlgCfgVcaEvent::OnBnClickedBtnVcaEventDrawStart)
	ON_BN_CLICKED(IDC_BTN_VCA_EVENT_DRAW_CLEAR, &CLS_DlgCfgVcaEvent::OnBnClickedBtnVcaEventDrawClear)
	ON_BN_CLICKED(IDC_BTN_VCA_EVENT_DRAW_COLOR, &CLS_DlgCfgVcaEvent::OnBnClickedBtnVcaEventDrawColor)
	ON_BN_CLICKED(IDC_BTN_VCA_EVENT_DRAW_GET, &CLS_DlgCfgVcaEvent::OnBnClickedBtnVcaEventDrawGet)
	ON_BN_CLICKED(IDC_BTN_VCA_EVENT_DRAW_SET, &CLS_DlgCfgVcaEvent::OnBnClickedBtnVcaEventDrawSet)
END_MESSAGE_MAP()


BOOL CLS_DlgCfgVcaEvent::OnInitDialog()
{
	CLS_CfgBasePage::OnInitDialog();

	InitCboVcaEvents();

	m_btnDisplayColor.SetChildNum(0);
	m_btnDisplayColor.SetColor(0, m_iDrawColor);

	return TRUE;
}

void CLS_DlgCfgVcaEvent::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CLS_CfgBasePage::OnShowWindow(bShow, nStatus);
	if (bShow)
	{
		//Ĭʾɫ
		try
		{
			m_btnDisplayColor.RemoveChild(0);
			m_btnDisplayColor.AddChild(0);
			m_btnDisplayColor.SetColor(0,RGB(GetRValue(m_iDrawColor), GetGValue(m_iDrawColor),GetBValue(m_iDrawColor)));
		}
		catch (CException* e)
		{
			e->ReportError();
			e->Delete();
		}
	}
}

int CLS_DlgCfgVcaEvent::InitCboVcaEvents()
{	
	//
	m_cboVcaEvent.SetItemData(m_cboVcaEvent.AddString("Tripwire"), DRAW_VCA_TRIPWIRE);
	//˫
	m_cboVcaEvent.SetItemData(m_cboVcaEvent.AddString("Double Tripwire"), DRAW_VCA_MULITTRIP);
	//ܽ
	m_cboVcaEvent.SetItemData(m_cboVcaEvent.AddString("Boundary"), DRAW_VCA_BOUNDARY);
	//Ʒ
	m_cboVcaEvent.SetItemData(m_cboVcaEvent.AddString("Left"), DRAW_VCA_LEFT);
	//Ʒʧ
	m_cboVcaEvent.SetItemData(m_cboVcaEvent.AddString("Lost"), DRAW_VCA_LOST);
	//ǻ
	m_cboVcaEvent.SetItemData(m_cboVcaEvent.AddString("Loiter"), DRAW_VCA_LOITER);
	//
	m_cboVcaEvent.SetItemData(m_cboVcaEvent.AddString("Running"), DRAW_VCA_RUNNING);
	//ͣ
	m_cboVcaEvent.SetItemData(m_cboVcaEvent.AddString("Parking"), DRAW_VCA_PARKING);
	//ʶ
	m_cboVcaEvent.SetItemData(m_cboVcaEvent.AddString("LPR"), DRAW_VCA_LPR);
	//
	m_cboVcaEvent.SetItemData(m_cboVcaEvent.AddString("Face Detection"), DRAW_VCA_FACE_DETECTION);	
	//ͳ
	m_cboVcaEvent.SetItemData(m_cboVcaEvent.AddString("Demographics"), DRAW_VCA_DEMOGRAPHICS);	
	//Ⱥۼ
	m_cboVcaEvent.SetItemData(m_cboVcaEvent.AddString("Crow Detection"), DRAW_VCA_CROWD_DETECTION);	
	//ֵڼ
	m_cboVcaEvent.SetItemData(m_cboVcaEvent.AddString("On Duty Detection"), DRAW_VCA_ONDUTY_DETECTION);	
	//Υͣ
	m_cboVcaEvent.SetItemData(m_cboVcaEvent.AddString("IllegalPark"), DRAW_VCA_ILLEGAL_PARK);

	//TODOʱ
	//ص
	m_cboVcaEvent.SetItemData(m_cboVcaEvent.AddString("Insterested Area"), DRAW_VIDEO_ROI);
	//̶ڵ
	m_cboVcaEvent.SetItemData(m_cboVcaEvent.AddString("Fix Shade"), DRAW_VIDEO_FIX_SHADE);
	//̬ڵ
	m_cboVcaEvent.SetItemData(m_cboVcaEvent.AddString("Dyn Shade"), DRAW_VIDEO_DYN_SHADE);
	//ⲹ
	m_cboVcaEvent.SetItemData(m_cboVcaEvent.AddString("WDR Back Light"), DRAW_WDR_BACK_LIGHT);
	//ƶ
	m_cboVcaEvent.SetItemData(m_cboVcaEvent.AddString("Alarm Move"), DRAW_ALARM_MOVE);


	//Ĭʾ
	m_cboVcaEvent.SetCurSel(0);
	return 0;
}

//ʼ\ֹͣ
void CLS_DlgCfgVcaEvent::OnBnClickedBtnVcaEventDrawStart()
{
	if (!m_blDrawing)
	{
		int iDrawType = m_cboVcaEvent.GetItemData(m_cboVcaEvent.GetCurSel());
		Swallow_StartDraw(m_pSwallowCfg, m_lObsId, iDrawType);
		Swallow_SetDrawColor(m_pSwallowCfg, m_lObsId, m_iDrawColor);
		SetDlgItemText(IDC_BTN_VCA_EVENT_DRAW_START, "StopDraw");
		m_blDrawing = true;
	}
	else
	{
		Swallow_StopDraw(m_pSwallowCfg, m_lObsId);
		SetDlgItemText(IDC_BTN_VCA_EVENT_DRAW_START, "StartDraw");
		m_blDrawing = false;
	}	
}

//
void CLS_DlgCfgVcaEvent::OnBnClickedBtnVcaEventDrawClear()
{
	Swallow_ClearDraw(m_pSwallowCfg, m_lObsId);	
}

//ѡɫ
void CLS_DlgCfgVcaEvent::OnBnClickedBtnVcaEventDrawColor()
{
	CColorDialog clsColorDlg;
	int iRet = clsColorDlg.DoModal();
	if (IDOK == iRet)
	{
		m_iDrawColor = clsColorDlg.GetColor();
		try
		{
			m_btnDisplayColor.RemoveChild(0);
			m_btnDisplayColor.AddChild(0);
			m_btnDisplayColor.SetColor(0,RGB(GetRValue(m_iDrawColor), GetGValue(m_iDrawColor),GetBValue(m_iDrawColor)));

			Swallow_SetDrawColor(m_pSwallowCfg, m_lObsId, m_iDrawColor);
		}
		catch (CException* e)
		{
			e->ReportError();
			e->Delete();
		}
	}
}

//ѡ¼
void CLS_DlgCfgVcaEvent::OnCbnSelchangeCboVcaEvents()
{
	static int iSelOld = -1;
	int iSelNew = m_cboVcaEvent.GetCurSel();
	if (iSelNew == iSelOld)
	{
		return;
	}

	Swallow_StopDraw(m_pSwallowCfg, m_lObsId);
	SetDlgItemText(IDC_BTN_VCA_EVENT_DRAW_START, "StartDraw");
	m_blDrawing = false;
	iSelOld = iSelNew;
}

void CLS_DlgCfgVcaEvent::OnBnClickedBtnVcaEventDrawGet()
{
	CString cstrDrawInfo;
	 Swallow_GetDrawInfo(m_pSwallowCfg, m_lObsId, cstrDrawInfo);
	SetDlgItemText(IDC_STC_SHOW_DRAW_INFO, cstrDrawInfo);
}

void CLS_DlgCfgVcaEvent::OnBnClickedBtnVcaEventDrawSet()
{
	Swallow_SetDrawInfo(m_pSwallowCfg, m_lObsId, 0);
}
