
#ifndef __GLOBAL_TYPES_H__
#define __GLOBAL_TYPES_H__

#if (defined(_WIN32) || defined(_WIN64)) && !defined(__WIN__)
#define __WIN__
#endif

#ifndef __WIN__
#include <stdlib.h>
#include <sys/resource.h>
#endif

#ifndef __WIN__
typedef struct _RECT 
{ 
    int left; 
    int top; 
    int right; 
    int bottom; 
}RECT, *LPRECT;

typedef struct tagPOINT
{
    int  x;
    int  y;
}POINT, *LPPOINT;
#define __stdcall
#else
#define WIN32_LEAN_AND_MEAN 
#include <windows.h>
#endif

/**************************************************************/
//صYUV
typedef struct tagDecAVInfo
{
    int iType;   // 0Ƶ  1:Ƶ 
    int iFormat;
    int iWidth;
    int iHeight;
    const unsigned char *pucData;
    int iDataLen;
}DecAVInfo, *PDecAVInfo;

typedef struct tagDecAVInfoEx
{
	DecAVInfo 	m_pInfo;

	//	OtherInfoSizeжϺľϢṹ, 1:TimeStamp(unsigned int), 2:FrameRate(int)
	int			m_iOtherInfoSize;		
	void*		m_pvOtherInfo;
}DecAVInfoEx, *PDecAVInfoEx;

#ifndef __WIN__
typedef void (*pfCBGetDecAV)(int _iID, const DecAVInfo* _pDecAVInfo, void* _iUser);
#endif
/****************************************************************/

#define VCA_MAX_POLYGON_POINT_NUM		16				//	ÿ
#define VCA_MAX_POLYGON_POINT_NUMEX		32				//  Max Tripwire Points Number
#define VCA_MAX_POLYGON_NUM				25				//	ÿVCAĶθ
#define MAX_AREA_NUM					4				//  Max Area Number for 300w Leave Detect

//////////////////////////////////////////////////////////////////
/*****************     ¼ļдܷϢ   ***************/
#define MAX_SAVE_TARGET_NUM  16

#define VCAINFO_SEARCHRULE_MIN				0
#define VCAINFO_SEARCHRULE_FRAME			(VCAINFO_SEARCHRULE_MIN+0)
#define VCAINFO_SEARCHRULE_POLYGON			(VCAINFO_SEARCHRULE_MIN+1)
#define VCAINFO_SEARCHRULE_TRIPWIRE			(VCAINFO_SEARCHRULE_MIN+2)
#define VCAINFO_SEARCHRULE_MAX				(VCAINFO_SEARCHRULE_MIN+3)

typedef struct tagvca_TRect
{
	unsigned short usLeft;
	unsigned short usTop;
	unsigned short usRight;
	unsigned short usBottom;
} vca_TRect, *pvca_TRect;

typedef struct tagvca_TTargetInfo
{
	vca_TRect		rect;
	unsigned short	usType;
	unsigned short	usVelocity;
	unsigned short	usDirection;
	unsigned int	id;	
} vca_TTargetInfo, *pvca_TTargetInfo;

typedef struct tagvca_TTargetSet
{
	unsigned short		usCount;
	vca_TTargetInfo		targets[MAX_SAVE_TARGET_NUM]; 
} vca_TTargetSet, *pvca_TTargetSet;

typedef struct tagvca_TTotalInfo
{
	unsigned short		usType;
	unsigned short		usLength;
	vca_TTargetSet		targetSet;
} vca_TTotalInfo, *pvca_TTotalInfo;

typedef struct __tagTStreamData
{
	int  iSize;
	char cStreamData[64];
	int   iStreamLen;
} TStreamData, *PTStreamData;

//NVSSDKPlaySDKM4õĽṹ
//Version message structure, with which to transmit SDK version message
typedef struct
{
    unsigned short  m_ulMajorVersion;
    unsigned short  m_ulMinorVersion;
    unsigned short  m_ulBuilder;
    char*           m_cVerInfo;
}SDK_VERSION;

#define MAX_MONITOR_DESCLEN 512
typedef struct MONITOR_INFO					
{
	char        cDriverDesc[MAX_MONITOR_DESCLEN];
	char        cDriverName[MAX_MONITOR_DESCLEN];	
	RECT		rect;
}*PMONITOR_INFO;

typedef struct PSPACK_INFO
{
	unsigned long nWidth;
	unsigned long nHeight;
	unsigned long nStamp;
	unsigned long nType;
	unsigned long nFrameRate;
	unsigned long nReserved;
}*PPSPACK_INFO;

typedef struct
{
	unsigned long nWidth;    //Video width, audio data is 0
	unsigned long nHeight;   //Video height, audio data is 0
	unsigned long nStamp;    //Time stamp(ms)
	unsigned long nType;     //Audio typeT_AUDIO8,T_YUV420
	unsigned long nFrameRate;//Frame rate
	unsigned long nReserved; //reserve
}FRAME_INFO;

typedef struct __tagExtraInfo
{
	int		m_iInfoLen;
	void*	m_pvExtInfo;	
}FRAME_EXT_INFO, *LPFRAME_EXT_INFO;

//frame absoluteTime time parameter
typedef struct tagAbsoluteTime
{
	unsigned short	iYear;			/* Year */
	unsigned short	iMonth;			/* Month */
	unsigned short	iDay;			/* Day */
	unsigned short	iHour;			/* Hour */
	unsigned short	iMinute;		/* Minute */
	unsigned short	iSecond;		/* Second */
	unsigned int	uiTime;
} AbsoluteTime, *pAbsoluteTime;

#define VITAL_SIGN_HR	1		//
#define VITAL_SIGN_BO	2		//Ѫ
#define VITAL_SIGN_BP	3		//Ѫѹ 
#define MAX_POINTS_NUM	512
//ɼݷװ
typedef struct __tagVitalSignData 
{
	char cVersion;				//Э汾
	char cType;					//ɼ,1 2Ѫ 3Ѫѹ
	char cMonFlg;					//1:2: 34: 5:豸    
	char iOscilloGramSeqID;		//1ʼĵδ123Ѫһʹ1
	int iMonVal[4];				//ʵʱֵ, Ѫѹ3,SYS DIA PRδţȣԭֵ100;
	int iGramRate;				//1sжٸ
	int iSizeType;				// ƵӲС  1: 2 3С
	int iXPosition;				// ƵϽ(0,0)Ժ(ֱ)
	int iYPosition;				// ƵϽ(0,0)(ֱ)
	int iPointLen;
	unsigned char cPointValue[MAX_POINTS_NUM];
} VitalSignData, *pVitalSignData;

//Tvca_cpcInfoڴͳƽ£
typedef struct tagTvca_cpcInfo
{
	short 	sCountIn;
	short 	sCountOut;
} Tvca_cpcInfo, *pTvca_cpcInfo;

typedef struct tagTvca_CpcData
{
	Tvca_cpcInfo 	tCpcInfo;		/*ͳƽ*/
	vca_TTargetSet	tVCATarget;		/*Ŀλ*/
} Tvca_CpcData, *pTvca_CpcData;

typedef struct tagTvca_RGB
{
	unsigned char 	ucR;
	unsigned char 	ucG;
	unsigned char 	ucB;
} Tvca_RGB, *pTvca_RGB;

// ɫ
#define LPR_PLATE_COLOR_WHITE		0		// 
#define LPR_PLATE_COLOR_YELLOW		1		// 
#define LPR_PLATE_COLOR_BLUE		2		// 
#define LPR_PLATE_COLOR_BLACK		3		// 
#define LPR_PLATE_COLOR_GREEN		4		// 
#define LPR_PLATE_COLOR_UNKNOWN		99		// 

//Ŀǰֵ֧ĳ
#define LPR_VT_UNKOWN							0		//δ֪
#define LPR_VT_BUS								1		//ʹͳ
#define LPR_VT_CAR								2		//С
#define LPR_VT_TRUCK							3		//С
#define LPR_VT_VAN								4		//
#define LPR_VT_BIG_TRUCK						5		//
#define LPR_VT_SMALL_TRUCK						6		//С
#define LPR_VT_TWO_THREE_WHEELER				7		//ֳ
#define LPR_VT_PERSON							8		//	
#define LPR_VT_SUV								9		//SUV
#define LPR_VT_MID_BUS							10		//Ϳͳ
#define LPR_VT_BGS								14		//
#define LPR_VT_OTHER							15		//ģ

// 
#define LPR_PLATE_TYPE_UNKOWN			   					0	// δ֪
#define LPR_PLATE_TYPE_BIG		               				1	// 
#define LPR_PLATE_TYPE_SMALL	               				2	// С
#define LPR_PLATE_TYPE_AMBASSADOR							3	// ʹݳ
#define LPR_PLATE_YTPE_COUSULATE          					4	// 
#define LPR_PLATE_YTPE_OVERSEAS								5	// 
#define LPR_PLATE_YTPE_FOREIGN								6	// ⼮
#define LPR_PLATE_YTPE_TWO_THREE_WHEELES					7	// Ħг
#define LPR_PLATE_TYPE_MOTOR								8	// Ħг
#define LPR_PLATE_TYPE_MOTOR_AMBASSADOR						9	// ʹĦг
#define LPR_PLATE_TYPE_MOTOR_COUSULATE						10	// Ħг
#define LPR_PLATE_TYPE_MOTOR_OVERSEAS						11	// Ħг
#define LPR_PLATE_TYPE_MOTOR_FOREIGN						12	// ⼮Ħг
#define LPR_PLATE_TYPE_FARM									13	// ũ䳵
#define LPR_PLATE_TYPE_TRACTOR								14	// 
#define LPR_PLATE_TYPE_GUA									15	// ҡ
#define LPR_PLATE_TYPE_COACH								16	// 
#define LPR_PLATE_TYPE_COACH_MOTOR							17	// Ħг
#define LPR_PLATE_TYPE_TRIAL								18	// 
#define LPR_PLATE_TYPE_TRIAL_MOTOR							19	// Ħг
#define LPR_PLATE_TYPE_LIAOTEMP_ENTER						20	// ʱ뾳
#define LPR_PLATE_TYPE_LIAOTEMP_MOTOR_ENTER					21	// ʱ뾳Ħг
#define LPR_PLATE_TYPE_LIAOTEMP								22	// ʱʻ
#define LPR_PLATE_TYPE_POLICE								23  // 
#define LPR_PLATE_TYPE_POLICE_MOTOR							24  // Ħ
#define LPR_PLATE_TYPE_BIKE									99	// 綯г

//
#define LPR_LOGO_UNKNOWN			0
#define LPR_LOGO_VOLKSWAGEN			1	//Volkswagen(˹/)
#define LPR_LOGO_AUDI				2	//µ
#define LPR_LOGO_TOYOTA				3	//Toyota 
#define LPR_LOGO_HONDA				4	//Honda 
#define LPR_LOGO_BENZ				5	//
#define LPR_LOGO_CHEVROLET			6	//ѩ
#define LPR_LOGO_CHEERY				7	//Chery Automobile Corporation
#define LPR_LOGO_BUICK				8	//
#define LPR_LOGO_GREATWALL			9	//GreatWall()
#define LPR_LOGO_HYUNDAI			10	//Hyundai ִ
#define LPR_LOGO_NISSAN				11	//Nissan ղ
#define LPR_LOGO_FORD				12	//Ford 
#define LPR_LOGO_BMW				13	//
#define LPR_LOGO_CITROEN			14	//Citroen ѩ
#define LPR_LOGO_KIA				15	//Kia 
#define LPR_LOGO_SUZUKI				16	//Suzuki ľ
#define LPR_LOGO_MAZDA				17	//Mazda Դ
#define LPR_LOGO_BUILDYD			18	//ǵbuild your dreams
#define LPR_LOGO_PEUGEOT			20	//Peugeot 	
#define LPR_LOGO_CCAG				21	//쳤
#define LPR_LOGO_JAC          		22	//
#define LPR_LOGO_ZHONGHUA			23	//л
#define LPR_LOGO_SKODA				24	//˹´
#define LPR_LOGO_HAIMA				25	//	
#define LPR_LOGO_XIALI				26	//Xiali
#define LPR_LOGO_SGMW				27	//Ϻͨ⣺SGMW
#define LPR_LOGO_DONGFENG			28	//DongFeng()
#define LPR_LOGO_HAFEI				29	//
#define LPR_LOGO_FAWCAR				30	//First Automobile Works(һ)
#define LPR_LOGO_BAOJUN				31	//
#define LPR_LOGO_EMGRAND			25	//ۺ
#define LPR_LOGO_MG					27	//
#define LPR_LOGO_SOUTHEAST			34	//
#define LPR_LOGO_CROWN				35	//ʹ
#define LPR_LOGO_JINBEI				36	//
#define LPR_LOGO_MITSUBISHI			37	//Mitsubishi 	
#define LPR_LOGO_ROEWE				38	//
#define LPR_LOGO_GEELY				39	//
#define LPR_LOGO_ENGLONCAR			40	//Ӣ
#define LPR_LOGO_GLEAGLE			41	//ȫӥ
#define LPR_LOGO_SAIBAO				42	//
#define LPR_LOGO_CHANGFENG			43	//
#define LPR_LOGO_WINWON				44	//
#define LPR_LOGO_BEIJING			45	//
#define LPR_LOGO_XINTIAN			46	//¿
#define LPR_LOGO_JIAO				47	//
#define LPR_LOGO_MASERRATI			48	//ɯ
#define LPR_LOGO_ROVER           	49	//
#define LPR_LOGO_AUSTIN          	50	//˹
#define LPR_LOGO_MARX				51	//˹
#define LPR_LOGO_DAOQI				52	//˹յ
#define LPR_LOGO_SHUNFENG			53	//˹˳
#define LPR_LOGO_GENERAL			54	//ͨӵٿ
#define LPR_LOGO_JAGUAR				55	//ݱ
#define LPR_LOGO_OZZY				56	//
#define LPR_LOGO_ALPHA              57	//
#define LPR_LOGO_LAMBORGHINI		58	//
#define LPR_LOGO_BUGATTI			59	//ӵ
#define LPR_LOGO_LINCOLN			60	//ֿ
#define LPR_LOGO_FETTARI			61	//
#define LPR_LOGO_CHANGHE         	62	//
#define LPR_LOGO_FIAT               63	//
#define LPR_LOGO_FUKUDA           	64	//
#define LPR_LOGO_ACURA				65	//ک
#define LPR_LOGO_LOTUS        		66	//
#define LPR_LOGO_MAPLE				67	//
#define LPR_LOGO_REDFLAG     		68	//
#define LPR_LOGO_RUIQI              69	//
#define LPR_LOGO_PENTIUM         	70	//
#define LPR_LOGO_WEILIN             71	//
#define LPR_LOGO_ZHONGTAI        	72	//̩
#define LPR_LOGO_LIFAN              73	//
#define LPR_LOGO_NJJEEP				74	//
#define LPR_LOGO_ZHONGXIN			75	//
#define LPR_LOGO_KAIRUI				76	// 
#define LPR_LOGO_LANDROVER  		77	//·
#define LPR_LOGO_MCG				78	//ͺ
#define LPR_LOGO_LEINUO         	79	// ŵ
#define LPR_LOGO_OPEL               80	//ŷ
#define LPR_LOGO_EILDHORSE			81	//Ұ
#define LPR_LOGO_JEEP				82	//JEEP
#define LPR_LOGO_IVECO              83	//ά
#define LPR_LOGO_INFINITI			84	//Ӣ
#define LPR_LOGO_SUBARU				85	//˹³
#define LPR_LOGO_ASTON				86	// ˹
#define LPR_LOGO_ANKAI				87	//
#define LPR_LOGO_PARSCHE			88	//ʱ
#define LPR_LOGO_BENTLEY			89	//
#define LPR_LOGO_FODDY				90	//
#define LPR_LOGO_KAITENG            91	//
#define LPR_LOGO_GEMS               92	//ķ˹
#define LPR_LOGO_QOROS				93	//
#define LPR_LOGO_TRUMPCHI           94	//
#define LPR_LOGO_SSANGYONG			95	// ˫
#define LPR_LOGO_HAIGER             96	//
#define LPR_LOGO_HUMMER				97  //
#define LPR_LOGO_HUATAI             98	//̩
#define LPR_LOGO_HUANGHAI			99	//ƺ
#define LPR_LOGO_KOWLOON			100	//
#define LPR_LOGO_IDEA				101	//
#define LPR_LOGO_SMART				102	//SMART
#define LPR_LOGO_TERRAL				103	//½
#define LPR_LOGO_NAZHIJIE           104	//ǽ
#define LPR_LOGO_ELEGANZA			105	//ŷ
#define LPR_LOGO_KAICHEN            106	//
#define LPR_LOGO_ORHER              999	//


//Ŀǰֵ֧Υ
#define LPR_IT_UNKOWN				0		//δ֪
#define LPR_IT_NOSAFETYBELT			1		//ϵȫ
#define LPR_IT_PHONE				2		//绰
#define LPR_IT_NOPRESSLINE			4		//ûѹߡΥ
#define LPR_IT_NOILL				8		//ûΥ羯ץΥ¼

// ַ
#define LPR_PLATE_STR_LEN		11

#define MAX_OUTPUT_LPR_NUM		10

typedef struct tagTvca_LPRInfo
{
	Tvca_RGB    stCarColor;						// ɫ
	int			iPlateColor;					// ɫ
	int      	iCarType;						// 
	int	      	iPlateType;						// 
	int			iBrandType;						// 
	int			iIllgalType;					// Υ
	vca_TRect	stRectPlate;					// λþ
	vca_TRect   stRectFace;						// 
	vca_TRect   stRectLogo;						// 
	char		cPlateRec[LPR_PLATE_STR_LEN];	// ƺ
	int         iHeadTail;						// ͷǳβ:0δ֪,1ͷ,2β
	vca_TRect   stRectCopilotFace;				// ʻ
	vca_TRect   stCarRegion;					// 
} Tvca_LPRInfo, *pTvca_LPRInfo;

typedef struct tagTvca_LPRData
{
	int					iNumOutputs;	//Ŀ
	int					iSize;			//뵥Tvca_LPRInfoṹС
	Tvca_LPRInfo		stOutputs[MAX_OUTPUT_LPR_NUM];		//
} Tvca_LPRData, *pTvca_LPRData;

/*****************************************************************************/
#define GET_USERDATA_INFO_MIN                        (0)                           
#define GET_USERDATA_INFO_TIME						 (GET_USERDATA_INFO_MIN )			//ûеʱϢ
#define GET_USERDATA_INFO_OSD						 (GET_USERDATA_INFO_MIN + 1)		//ûеOSDϢ
#define GET_USERDATA_INFO_GPS                        (GET_USERDATA_INFO_MIN + 2)		//ûеGPSϢ
#define GET_USERDATA_INFO_VCA                        (GET_USERDATA_INFO_MIN + 3)		//ûеVCAϢ
#define GET_USERDATA_INFO_USER_DEFINE                (GET_USERDATA_INFO_MIN + 4)		//ûеԶϢ
#define GET_USERDATA_INFO_VITAL_SIGN_DATA			 (GET_USERDATA_INFO_MIN + 5)		//ûеϢ
#define GET_USERDATA_INFO_DEMOGRAPHICS				 (GET_USERDATA_INFO_MIN + 6)		//ûеͳƽ
#define GET_USERDATA_INFO_LPR						 (GET_USERDATA_INFO_MIN + 7)		//ûеĳʶϢ
#define GET_USERDATA_INFO_MAX                        (GET_USERDATA_INFO_MIN + 8)	
/*****************************************************************************/
#define GET_ALL_USERDATA_INFO			(0xFF) 

typedef struct tagAllUserDataInfo
{
	AbsoluteTime	tFrameTime;
	TStreamData		tUserDefineData;
	VitalSignData	tVitalSignData;
	Tvca_CpcData	tCpcData;
	Tvca_LPRData	tLprData;
	bool		blHasAbsoluteTime;
	bool		blHasDefineData;
	bool		blHasCpcData;
	bool		blHasLPRData;
	bool		blHasVitalSignData;
} AllUserDataInfo, *pAllUserDataInfo;

typedef struct _tagCurrentFrameInfo
{
	unsigned int	uiSize;			//size of struct
	unsigned int	uiFrameNO;		//frame index
	unsigned int	uiFrameType;	//frame type:I=0, P=1,B=2
	unsigned int	uiTimeStamp;	//time stamp 
} CurrentFrameInfo, *pCurrentFrameInfo;

typedef void (__stdcall *DEVUSERDATA_NOTIFY)(unsigned int _uiID, int _iType, void* _pvData
											 , int _iDataLen, CurrentFrameInfo* _ptInfo, void* _pvUdata);

//Ƶ
typedef void (*DECYUV_NOTIFY_V4)(unsigned int _ulID,unsigned char *_cData, int _iLen, const FRAME_INFO *_pFrameInfo, void* _iUser);

typedef int  (*PSPACK_NOTIFY)(int _iPlayerID, unsigned char* _ucData, int _iSize, PSPACK_INFO* _pPsPackInfo, void* _pContext);


#define AUTOTEST_PARAM_SIZE		5
#define AUTOTEST_STRING_SIZE	65

typedef struct _strAutoTest_Para
{
	int     iTestParam[AUTOTEST_PARAM_SIZE];
	char    cTestParam[AUTOTEST_STRING_SIZE];
}strAutoTest_Para;

#define LEN_2   2
#define LEN_8   8
#define LEN_10	10
#define LEN_16  16
#define LEN_17  17
#define LEN_32  32
#define LEN_33  33
#define LEN_36  36
#define LEN_64  64
#define LEN_65  65
#define LEN_63  63
#define LEN_128 128
#define LEN_250 250
#define LEN_256 256
#define LEN_300 300
#define LEN_1300 1300 //һЭ鲻ȫ͵Э飬ֶַθ65ֽMAX1300/65 = 20.ʣ140ֽڱintͱ

typedef struct			//ƵͨϢ
{
	char    m_cParam1[LEN_64];
	char    m_cParam2[LEN_64];
	char    m_cParam3[LEN_64];
	char    m_cParam4[LEN_64];
	char    m_cParam5[LEN_64];
	char    m_cParam6[LEN_64];
	char    m_cParam7[LEN_64];
	char    m_cParam8[LEN_64];
	char    m_cParam9[LEN_64];
	char    m_cParam10[LEN_64];
	char    m_cParam11[LEN_64];
	char    m_cParam12[LEN_64];
	char    m_cParam13[LEN_64];
	char    m_cParam14[LEN_64];
	char    m_cParam15[LEN_64];
	char    m_cParam16[LEN_64];
	char    m_cParam17[LEN_64];
	char    m_cParam18[LEN_64];
	char    m_cParam19[LEN_64];
	char    m_cParam20[LEN_64];
}DZ_INFO_PARAM, *PDZ_INFO_PARAM;


//#define SIP_CMD_SET_MIN						(SIP_CMD_GET_MAX)		//	չ
#define SIP_CMD_SET_MIN						(2)
#define SIP_CMD_SET_ALARMCHANNEL			(SIP_CMD_SET_MIN+0)
#define SIP_CMD_SET_VIDEOCHANNEL			(SIP_CMD_SET_MIN+1)
#define SIP_CMD_SET_MAX						(SIP_CMD_SET_MIN+2)



#endif
