﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Text.RegularExpressions;

namespace SwallowDemo
{
    public partial class Preview : Form
    {
        private const int Sys_Cleanup_Cmd					   = 0x00000001;

        private const int Entry_Logon_Cmd                     = 0x00010000;
        private const int Entry_Logoff_Cmd                    = 0x00010001;
        private const int Entry_Prop_Get					   = 0x00010002;
        private const int Entry_Volume_Set                    = 0x00010006;
        private const int Entry_Config_Get                    = 0x00010007;

        //Obs显示窗体命令
        private const int Obs_Prop_Get                        = 0x00020000;
        private const int Obs_FullScreen_Cmd                  = 0x00020001;
        private const int Obs_Add_Cmd                         = 0x00020002;
        private const int Obs_Remove_Cmd                      = 0x00020003;
        private const int Obs_StartRealTime_Cmd               = 0x00020004;
        private const int Obs_StartPlayBack_Cmd			   = 0x00020005;
        private const int Obs_Pause_Cmd					   = 0x00020006;
        private const int Obs_FastForward_Cmd				   = 0x00020007;
        private const int Obs_SlowForward_Cmd				   = 0x00020008;
        private const int Obs_Stop_Cmd                        = 0x00020009;
        private const int Obs_ShowParam_Cmd				   = 0x0002000a;
        private const int Obs_MicEnable_Set				   = 0x0002000b;
        private const int Obs_SpeakerEnable_Set			   = 0x0002000c;
        private const int Obs_Capture_Cmd					   = 0x0002000d;
        private const int Obs_BeginRec_Cmd                    = 0x0002000e;
        private const int Obs_EndRec_Cmd                      = 0x0002000f;
        private const int Obs_Progress_Get				       = 0x00020010;
        private const int Obs_ShowMsg_Cmd                     = 0x00020011;
        private const int Obs_Volume_Set					   = 0x00020012;
        private const int Obs_Volume_Get					   = 0x00020013;
        private const int Obs_Monopolize_Cmd                  = 0x00020014;
        private const int Obs_StartPlayBackOffLine_Cmd	       = 0x00020015;
        private const int Obs_3dLocateEnable_Set			   = 0x00020016;
        private const int Obs_3dLocateEnable_Get			   = 0x00020017;
        private const int Obs_StopPause_Set                   = 0x00020018;

//         private const int Dev_Type_Set					       = 0x00030000;
//         private const int Dev_Type_Get					       = 0x00030001;
        private const int Dev_AllType_Get                     = 0x00030002;
        private const int Dev_Control_Cmd                     = 0x00030004;
        private const int Dev_Model_Get                       = 0x00030005;
        private const int Dev_Device_Ctrl					   = 0x00030006;
        private const int Dev_DeviceType_Set				   = 0x00030009;
        private const int Dev_DeviceType_Get				   = 0x0003000a;
        private const int Dev_SetComFormat_Set			       = 0x0003000b;
        private const int Dev_SetComFormat_Get			       = 0x0003000c;
        
        private const int Video_Display_Set				   = 0x00070005;
        private const int Video_Display_Get				   = 0x00070006;

        private const int DEVICE_DECRYPT_SET = 0x00140000;
        private const int DEVICE_DECRYPT_GET = 0x00140001;


        private const int WCM_NEED_DECRYPT_KEY = 36;
        private const int WCM_DECRYPT_KEY_FAILED = 37;
        private const int WCM_DECRYPT_SUCCESS = 38;

        //设备型号
        private const int TC_NVSS				= 0x0000;
        private const int TC_NS621S				= 0x0010;			//	单路S视频服务器
        private const int TC_NS621S_USB			= 0x0011;			//	单路S视频服务器(带USB)
        private const int TC_NS224S				= 0x0020;			//	1/2/4路S视频服务器
        private const int TC_NC621S				= 0x0030;			//	S网络摄像机枪机，S网络快球
        private const int TC_NC8000S			= 0x0040;			//	华旗小球
        private const int TC_NC8001S			= 0x0041;			//	华旗小球wifi型
        private const int TC_NC8100S			= 0x0042;			//	卫士小球
        private const int TC_NC8101S			= 0x0043;			//	卫士小球wifi型
        private const int TC_NC8200S			= 0x0044;			//	网络摄像机枪机(CMOS)          
        private const int TC_NC8250				= 0x0050;			//	基于355的高清网络摄像机
        private const int TC_NC9010S2_MP		= 0x0051;			//	130万CCD有线高清网络摄像机
        private const int TC_NC9000S2_2MP		= 0x0052;			//	200万CMOS高清网络摄像机, 2010-07-14, @yys@
        private const int TC_NS621S2			= 0x0060;			//	S2系列单路
        private const int TC_NS324S2			= 0x0062;			//	S2系列4路
        private const int TC_NS628S2 			= 0x0064;			//	S2系列8路D1
        private const int TC_NC9010I_2MP		= 0x00A1;			//	E系列200万高清相机							
        private const int TC_NC9000I_5MP		= 0x00A2;			//	N系列500万高清相机				
        private const int TC_2816AN_SH			= 0x0100;			//	基于3511的8路CIF DVR
        private const int TC_2808AN_S_3511		= 0x0110;			//	基于3511的8路CIF DVR
        private const int TC_2816AN_SD			= 0x0120;			//	基于3520的16路D1 DVR
        private const int TC_2808AN_S_3515		= 0x0130;			//  基于3515的8路CIF DVR
        private const int TC_2804AN_MX			= 0x0131;			//	车载3GDVR
        private const int TC_2816AN_S			= 0x0140;			//	基于3520的16路CIF DVR
        private const int TC_H802BHX_T			= 0x0141;			//	基于3520的2路标清预审主机	
        private const int TC_1002S2_3C			= 0x0150;			//	基于3520的D1 NVR
        private const int TC_H908NC_H_V50		= 0x0161;			//	基于3520的2路高清庭审主机
        private const int TC_ND921S2_MP			= 0x0400;			//	S2系列高清网络视频解码器

        //Protocol Control
        private const int MOVE_UP_P = 1;                        //云台向上                              
        private const int MOVE_DOWN_P = 2;                      //云台向下
        private const int MOVE_LEFT_P = 3;                      //云台向左
        private const int MOVE_RIGHT_P = 4;                     //云台向右
        private const int MOVE_UP_RIGHT_P = 5;                  //云台右上
        private const int MOVE_UP_LEFT_P = 6;                   //云台左上
        private const int MOVE_DOWN_RIGHT_P = 7;                //云台右下
        private const int MOVE_DOWN_LEFT_P = 8;                 //云台左下
        private const int MOVE_STOP_P = 9;                      //云台停止
        private const int ZOOM_BIG_P = 10;                      //变倍大 
        private const int ZOOM_SMALL_P = 11;                    //变倍小 
        private const int FOCUS_NEAR_P = 13;                    //聚焦近
        private const int FOCUS_FAR_P = 14;                     //聚焦远  
        private const int IRIS_OPEN_P = 17;                     //光圈开 
        private const int IRIS_CLOSE_P = 18;                    //光圈关
        private const int RAIN_ON_P = 19;                       //雨刷开 
        private const int RAIN_OFF_P = 20;                      //雨刷关 
        private const int LIGHT_ON_P = 21;                      //灯光开 
        private const int LIGHT_OFF_P = 22;                     //灯光关
        private const int HOR_AUTO_P = 23;                      //水平自动
        private const int HOR_AUTO_STOP_P = 24;                 //停止水平自动
        private const int CALL_VIEW_P = 25;                     //调用预置位
        private const int SET_VIEW_P = 28;                      //设置预置位                  
        private const int POWER_ON_P = 29;                      //电源开 
        private const int POWER_OFF_P = 30;                     //电源关 
        private const int ASSISTANT_ON_P = 33;                  //辅助开 
        private const int ASSISTANT_OFF_P = 34;                 //辅助关 

        //Transparent Control
        private const int MOVE_UP = 1;
        private const int MOVE_UP_STOP = 2;
        private const int MOVE_DOWN = 3;
        private const int MOVE_DOWN_STOP = 4;
        private const int MOVE_LEFT = 5;
        private const int MOVE_LEFT_STOP = 6;
        private const int MOVE_RIGHT = 7;
        private const int MOVE_RIGHT_STOP = 8;
        private const int MOVE_UP_LEFT = 9;
        private const int MOVE_UP_LEFT_STOP = 10;
        private const int MOVE_UP_RIGHT = 11;
        private const int MOVE_UP_RIGHT_STOP = 12;
        private const int MOVE_DOWN_LEFT = 13;
        private const int MOVE_DOWN_LEFT_STOP = 14;
        private const int MOVE_DOWN_RIGHT = 15;
        private const int MOVE_DOWN_RIGHT_STOP = 16;
        private const int HOR_AUTO = 21;
        private const int HOR_AUTO_STOP = 22;
        private const int ZOOM_BIG = 31;
        private const int ZOOM_BIG_STOP = 32;
        private const int ZOOM_SMALL = 33;
        private const int ZOOM_SMALL_STOP = 34;
        private const int FOCUS_FAR = 35;
        private const int FOCUS_FAR_STOP = 36;
        private const int FOCUS_NEAR = 37;
        private const int FOCUS_NEAR_STOP = 38;
        private const int IRIS_OPEN = 39;
        private const int IRIS_OPEN_STOP = 40;
        private const int IRIS_CLOSE = 41;
        private const int IRIS_CLOSE_STOP = 42;
        private const int LIGHT_ON = 43;
        private const int LIGHT_OFF = 44;
        private const int POWER_ON = 45;
        private const int POWER_OFF = 46;
        private const int RAIN_ON = 47;
        private const int RAIN_OFF = 48;
        private const int MOVE = 60;
        private const int MOVE_STOP = 61;
        private const int CALL_VIEW = 62;
        private const int SET_VIEW = 63;

        private const int OBS_NUM = 16;
        private int m_iLogonID = -1;          //登录LogonID
        int[] Obs = new int[OBS_NUM]; //记录窗体的对象值
        Dictionary<int, string> m_mapProductName;
       
        public Preview()
        {
            InitializeComponent();

            cboChannel.Items.Add("CH1");
            cboChannel.SelectedIndex = 0;
            cboMode.SelectedIndex = 0;
            cboStream.SelectedIndex = 0;
            cboWorkMode.SelectedIndex = 1;

        }

        private void Form1_Load(object sender, EventArgs e)
        {

            if (ocxPreview.iInitializtion == -1)
            {
                AppendMsg("Initializtion error!\r\n\r\n");
                //MessageBox("iInitializtion error");
                return;
            }
            ocxPreview.iLanguage = 0;

            //初始化窗体 
            for (int i = 0; i < OBS_NUM; i++)
            {
                string[] strRet = ocxPreview.Commander(Obs_Add_Cmd, 0, 0, 0, 0, 0, 0, 0, 0, 0).Split('\n');
                int  iRet = Int32.Parse(strRet[0]);
                if (iRet == 0)
                {
                    Obs[i] = Int32.Parse(strRet[1]);
                }
                else
                {
                    Obs[i] = 0;
                    AppendMsg("Obs "+(i+1)+" Create Failed!\r\n\r\n");
                }
            }

            ocxPreview.Commander(Entry_Volume_Set, 50000, 0, 0, 0, 0, 0, 0, 0, 0);
            string[] strDevType = ocxPreview.Commander(Dev_AllType_Get, 0, 0, 0, 0, 0, 0, 0, 0, 0).Split('\n');
            cboProtocol.Items.AddRange(strDevType);
            cboProtocol.Items.RemoveAt(0);

            cboComPort.SelectedIndex = 0;

            btnMoveUp.Tag = (MOVE_UP << 16) + MOVE_UP_STOP;
            btnMoveDown.Tag = (MOVE_DOWN << 16) + MOVE_DOWN_STOP;
            btnMoveLeft.Tag = (MOVE_LEFT << 16) + MOVE_LEFT_STOP;
            btnMoveRight.Tag = (MOVE_RIGHT << 16) + MOVE_RIGHT_STOP;
            btnMoveLeftUp.Tag = (MOVE_UP_LEFT << 16) + MOVE_UP_LEFT_STOP;
            btnMoveRightUp.Tag = (MOVE_UP_RIGHT << 16) + MOVE_UP_RIGHT_STOP;
            btnMoveLeftDown.Tag = (MOVE_DOWN_LEFT << 16) + MOVE_DOWN_LEFT_STOP;
            btnMoveRightDown.Tag = (MOVE_DOWN_RIGHT << 16) + MOVE_DOWN_RIGHT_STOP;
            btnMoveAuto.Tag = (HOR_AUTO << 16) + HOR_AUTO_STOP;
            btnZoomBig.Tag = (ZOOM_BIG << 16) + ZOOM_BIG_STOP;
            btnZoomSmall.Tag = (ZOOM_SMALL << 16) + ZOOM_SMALL_STOP;
            btnIrisOpen.Tag = (IRIS_OPEN << 16) + IRIS_OPEN_STOP;
            btnIrisClose.Tag = (IRIS_CLOSE << 16) + IRIS_CLOSE_STOP;
            btnFocusNear.Tag = (FOCUS_NEAR << 16) + FOCUS_NEAR_STOP;
            btnFocusFar.Tag = (FOCUS_FAR << 16) + FOCUS_FAR_STOP;
            btnCallPreset.Tag = CALL_VIEW;
            btnSetPreset.Tag = SET_VIEW;
            chkLight.Tag = (LIGHT_ON << 16) + LIGHT_OFF;
            chkPower.Tag = (POWER_ON << 16) + POWER_OFF;
            chkRain.Tag = (RAIN_ON << 16) + RAIN_OFF;

            ProductNameInit();
        }

        //处理登录消息
        private void ocxSwallow_OnLogonMsg(object sender, AxSwallowLib._DSwallowEvents_LogonMsgEvent e)
        {
            if (e.lLogStatus==1)
            {
                m_iLogonID = e._lLogonID;
                ocxPreview.Commander(Obs_ShowMsg_Cmd, ocxPreview.CurObs,true,"登录成功",3000,0,0,0,0,0);

                int iPort = 3000, iChannelNum = 0, iConnetStatus = 0;
                string strIP = "", strProxyIP = "", strID = "", strUser = "", strPwd = "";
                GetLogonInfo(m_iLogonID, ref strIP, ref strProxyIP, 
                    ref strID, ref iPort,ref strUser, ref strPwd,
                    ref iChannelNum, ref iConnetStatus);
                UpdateChannel(iChannelNum);
                edtID.Text = strID;
                UpdateProductName();
            } 
            else if(e.lLogStatus==2)
            {
                ocxPreview.Commander(Obs_ShowMsg_Cmd, ocxPreview.CurObs, true, "登录超时", 3000, 0, 0, 0, 0, 0);
    
            }else if(e.lLogStatus==3)
            {
                ocxPreview.Commander(Obs_ShowMsg_Cmd, ocxPreview.CurObs, true, "登录失败，用户名密码错误", 3000, 0, 0, 0, 0, 0);
            }
            else if(e.lLogStatus==5)
            {
                ocxPreview.Commander(Obs_ShowMsg_Cmd, ocxPreview.CurObs, true, "登录失败，用户名密码错误", 3000, 0, 0, 0, 0, 0);
            }
            else if (e.lLogStatus == 6)
            {
                ocxPreview.Commander(Obs_ShowMsg_Cmd, ocxPreview.CurObs, true, "已经登录", 3000, 0, 0, 0, 0, 0);
            }
        }

        private void ProductNameInit()
        {
            m_mapProductName = new Dictionary<int, string>();
            m_mapProductName.Add(TC_NVSS,"TC_NVSS");
            m_mapProductName.Add(TC_NS621S,"TC_NS621S");
            m_mapProductName.Add(TC_NS621S_USB,"TC_NS621S_USB");
            m_mapProductName.Add(TC_NS224S,"TC_NS224S");
            m_mapProductName.Add(TC_NC621S,"TC_NC621S");
            m_mapProductName.Add(TC_NC8000S,"TC_NC8000S");
            m_mapProductName.Add(TC_NC8001S,"TC_NC8001S");
            m_mapProductName.Add(TC_NC8100S,"TC_NC8100S");
            m_mapProductName.Add(TC_NC8101S,"TC_NC8101S");
            m_mapProductName.Add(TC_NC8200S,"TC_NC8200S");
            m_mapProductName.Add(TC_NC8250,"TC_NC8250");
            m_mapProductName.Add(TC_NC9010S2_MP,"TC_NC9010S2_MP");
            m_mapProductName.Add(TC_NC9000S2_2MP,"TC_NC9000S2_2MP");
            m_mapProductName.Add(TC_NS621S2,"TC_NS621S2");
            m_mapProductName.Add(TC_NS324S2,"TC_NS324S2");
            m_mapProductName.Add(TC_NS628S2,"TC_NS628S2");
            m_mapProductName.Add(TC_NC9010I_2MP,"TC_NC9010I_2MP");
            m_mapProductName.Add(TC_NC9000I_5MP,"TC_NC9000I_5MP");
            m_mapProductName.Add(TC_2816AN_SH,"TC_2816AN_SH");
            m_mapProductName.Add(TC_2808AN_S_3511,"TC_2808AN_S_3511");
            m_mapProductName.Add(TC_2816AN_SD,"TC_2816AN_SD");
            m_mapProductName.Add(TC_2808AN_S_3515,"TC_2808AN_S_3515");
            m_mapProductName.Add(TC_2804AN_MX,"TC_2804AN_MX");
            m_mapProductName.Add(TC_2816AN_S,"TC_2816AN_S");
            m_mapProductName.Add(TC_H802BHX_T,"TC_H802BHX_T");
            m_mapProductName.Add(TC_1002S2_3C,"TC_1002S2_3C");
            m_mapProductName.Add(TC_H908NC_H_V50,"TC_H908NC_H_V50");
            m_mapProductName.Add(TC_ND921S2_MP, "TC_ND921S2_MP");
        }

        private void UpdateProductName()
        {
            string[] strRet = ocxPreview.Commander(Dev_Model_Get, m_iLogonID, 0, 0, 0, 0, 0, 0, 0, 0).Split('\n');
            int iRet = StrToInt(strRet[0]);
            if (iRet == 0)
            {
                int iProductType = StrToInt(strRet[1].Split('\b')[0]);
                if (m_mapProductName.ContainsKey(iProductType))
                {
                    edtProductName.Text = m_mapProductName[iProductType];
                }
                else
                {
                    edtProductName.Text = "undefine";
                }
            }
            else
            {
                AppendMsg("Get DevModel Failed! LogonID(" + m_iLogonID + ") Ret(" + iRet + ")\r\n\r\n");
            }
        }

        private void ocxSwallow_StartPlay(object sender, AxSwallowLib._DSwallowEvents_StartPlayEvent e)
        {
            AppendMsg("Video Head Arrived! ConnID(" + e._ulConnID+")\r\n\r\n");
            UpdateUI();
        }

        //登录
        private void btnLogon_Click(object sender, EventArgs e)
        {
            string strIP = edtIP.Text;          //主机IP 
            if (!IsValidIP(strIP))
            {
                MessageBox.Show("Please input a valid IP!");
                return;
            }

            string strProxy= edtProxyIP.Text;   //代理  
            if (!IsValidIP(strProxy))
            {
                strProxy = "";
            }
           
            string strUser = edtUser.Text;      //用户名
            string strPwd = edtPwd.Text;        //密码
            int iPort = StrToInt(edtPort.Text);
            string[] strRet = ocxPreview.Commander(Entry_Logon_Cmd, strProxy, strIP, strUser, strPwd, "", iPort, 0, 0, 0).Split('\n');                                            //
            if (StrToInt(strRet[0]) != 0)
            {
                AppendMsg("Logon Failed! Error("+strRet[0]+")\r\n\r\n");
            }
        }

        //断开
        private void btnLogoff_Click(object sender, EventArgs e)
        {
            ocxPreview.Commander(Entry_Logoff_Cmd, m_iLogonID, 0, 0, 0, 0, 0, 0, 0, 0);
            edtID.Text = "";
            edtProductName.Text = "";
        }
        //开始录像
        /*默认录像位置在 D:\NetVideoBrowser\Video\192.168.3.22 下
         录像位置可以通过接口修改*/
        private Int32 RecStart()
        {
            int iRet = StrToInt(ocxPreview.Commander(Obs_BeginRec_Cmd, ocxPreview.CurObs, 0, 30, 0, 0, 0, 0, 0, 0).Split('\n')[0]);
            if (iRet == 0)
            {
                AppendMsg("Obs(" + ocxPreview.CurObs + ") Start Record Success!\r\n\r\n");
            }
            else
            {
                AppendMsg("Obs(" + ocxPreview.CurObs + ") Start Record Failed! Error(" + iRet + ")\r\n\r\n");
            }
            return iRet;
        }

        //停止录像
        private Int32 RecStop()
        {
            int iRet = StrToInt(ocxPreview.Commander(Obs_EndRec_Cmd, ocxPreview.CurObs, 0, 0, 0, 0, 0, 0, 0, 0).Split('\n')[0]);
            if (iRet == 0)
            {
                AppendMsg("Obs(" + ocxPreview.CurObs + ") Stop Record Success!\r\n\r\n");
            }
            else
            {
                AppendMsg("Obs(" + ocxPreview.CurObs + ") Stop Record Failed! Error(" + iRet + ")\r\n\r\n");
            }
            return iRet;
        }

        private Int32 AudioStart()
        {
            int iRet = StrToInt(ocxPreview.Commander(Obs_SpeakerEnable_Set, ocxPreview.CurObs, 1, 0, 0, 0, 0, 0, 0, 0));
            if (iRet == 0)
            {
                AppendMsg("Obs(" + ocxPreview.CurObs + ") Start Audio Success!\r\n\r\n");
            }
            else
            {
                AppendMsg("Obs(" + ocxPreview.CurObs + ") Start Audio Failed! Error(" + iRet + ")\r\n\r\n");
            }
            return iRet;
        }

        private Int32 AudioStop()
        {
            int iRet = StrToInt(ocxPreview.Commander(Obs_SpeakerEnable_Set, ocxPreview.CurObs, 0, 0, 0, 0, 0, 0, 0, 0));
            if (iRet == 0)
            {
                AppendMsg("Obs(" + ocxPreview.CurObs + ") Stop Audio Success!\r\n\r\n");
            }
            else
            {
                AppendMsg("Obs(" + ocxPreview.CurObs + ") Stop Audio Failed! Error(" + iRet + ")\r\n\r\n");
            }
            return iRet;
        }

        private Int32 TalkStart()
        {
            int iRet = StrToInt(ocxPreview.Commander(Obs_MicEnable_Set, m_iLogonID, 1, 0, 0, 0, 0, 0, 0, 0));
            if (iRet != 0)
            {
                AppendMsg("Begin Talk Failed! LogonID(" + m_iLogonID + ") Error(" + iRet + ")\r\n\r\n");
            }
            return iRet;
        }

        private Int32 TalkStop()
        {
            int iRet = StrToInt(ocxPreview.Commander(Obs_MicEnable_Set, m_iLogonID, 0, 0, 0, 0, 0, 0, 0, 0));
            if (iRet != 0)
            {
                AppendMsg("End Talk Failed! LogonID(" + m_iLogonID + ") Error(" + iRet + ")\r\n\r\n");
            }
            return iRet;
        }

        private Int32 CapturePicture()
        {
            string strFileName = DateTime.Now.ToString("yyyyMMddHHmmssfff") + ".bmp";
            int iRet = StrToInt(ocxPreview.Commander(Obs_Capture_Cmd, ocxPreview.CurObs, strFileName, 0, 0, 0, 0, 0, 0, 0).Split('\n')[0]);
            if (iRet == 0)
            {
                AppendMsg("Obs(" + ocxPreview.CurObs + ") Capture Picture Success!\r\n\r\n");
            }
            else
            {
                AppendMsg("Obs(" + ocxPreview.CurObs + ") Capture Picture Failed! Error(" + iRet + ")\r\n\r\n");
            }
            return iRet;
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            ocxPreview.Commander(Sys_Cleanup_Cmd, 0, 0, 0, 0, 0, 0, 0, 0, 0);
        }

        private void ShowScreen(int iNum)
        {
            string strVisibleObs = "";
            bool blContainCurObs = false;
            for (int i = 0; i < iNum; i++)
            {
                strVisibleObs = strVisibleObs + Obs[i] + "\b";
                if (Obs[i] == ocxPreview.CurObs)
                {
                    blContainCurObs = true;
                }
            }
            strVisibleObs = strVisibleObs.Substring(0, strVisibleObs.Length - 1);

            ocxPreview.Commander(Obs_Monopolize_Cmd, strVisibleObs, 0, 0, 0, 0, 0, 0, 0, 0);
            if (!blContainCurObs)
            {
                ocxPreview.CurObs = Convert.ToUInt32(Obs[0]);
            }            
        }
      
        private void AppendMsg(string strMsg)
        {
            edtMsg.Text += strMsg;
        }

        private void edtMsg_DoubleClick(object sender, EventArgs e)
        {
            edtMsg.Text = "";
        }

        private bool IsValidIP(string strIP)
        {
            string strField = @"(25[0-5]|2[0-4]\d|1\d\d|\d\d|\d)";
            string strPattern = "^" + strField + @"\." + strField + 
                    @"\." + strField + @"\." + strField + "$";
            return Regex.IsMatch(strIP, strPattern);
        }

        private int Connect(UInt32 uiObsID,int iLogonID,int iChannel,
            int iStream,int iMode)
        {
            int iRet = StrToInt(ocxPreview.Commander(
                Obs_StartRealTime_Cmd, uiObsID, iLogonID, iChannel, 
                iStream, 0, 0, iMode, 0, 0));
            if (iRet < 0 || iRet > 1)
            {
                AppendMsg("Connect Failed! Obs(" + uiObsID + 
                    ") LogonID(" + m_iLogonID + ") Channel(" + 
                    iChannel + ") Stream(" + iStream + ") Mode(" + 
                    iMode + ") Ret(" + iRet + ")\r\n\r\n");
            }
            return iRet;
        }

        private int  Disconnect(UInt32 uiObsID)
        {
            int iRet = StrToInt(ocxPreview.Commander(Obs_Stop_Cmd, 
                ocxPreview.CurObs, 0, 0, 0, 0, 0, 0, 0, 0));
            if (iRet < 0)
            {
                AppendMsg("Obs(" + ocxPreview.CurObs + ") Disconnect Failed!\r\n\r\n");
            }
            return iRet;
        }

        private void btnConnect_Click(object sender, EventArgs e)
        {
            int iChannel = cboChannel.SelectedIndex;
            int iStream = cboStream.SelectedIndex;
            int iNetMode = cboMode.SelectedIndex + 1;
            Connect(ocxPreview.CurObs,m_iLogonID,iChannel,iStream,iNetMode);
        }

        private void btnScreen1_Click(object sender, EventArgs e)
        {
            ocxPreview.Commander(Obs_Monopolize_Cmd,
                ocxPreview.CurObs.ToString(), 0, 0, 0, 0, 0, 0, 0, 0);
        }

        private void btnScreen4_Click(object sender, EventArgs e)
        {
            ShowScreen(4);
        }

        private void btnScreen9_Click(object sender, EventArgs e)
        {
            ShowScreen(9);
        }

        private void btnScreen16_Click(object sender, EventArgs e)
        {
            ShowScreen(16);
        }

        private void btnRecordStart_Click(object sender, EventArgs e)
        {
            RecStart();
        }

        private void ocxSwallow_OnObsClicked(object sender, AxSwallowLib._DSwallowEvents_OnObsClickedEvent e)
        {
            UpdateUI();
        }

        private int GetLogonInfo(int iLogonID, ref string strIP, 
            ref string strProxyIP, ref string strID,
            ref int iPort, ref string strUser, ref string strPwd,
            ref int iChannelNum, ref int iConnetStatus) 
        {
            if (iLogonID < 0)
            {
                return -1;
            }

            string[] strRet = ocxPreview.Commander(Entry_Prop_Get, 
                iLogonID, 0, 0, 0, 0, 0, 0, 0, 0).Split('\n');
            int iRet = StrToInt(strRet[0]);
            if (iRet == 0)
            {
                string[] strEntryProp = strRet[1].Split('\b');
                iConnetStatus = StrToInt(strEntryProp[0]);
                strProxyIP = strEntryProp[1];
                strIP = strEntryProp[2];
                strID = strEntryProp[3];
                iPort = StrToInt(strEntryProp[4]);
                iChannelNum = StrToInt(strEntryProp[5]);
                strUser = strEntryProp[6];
                strPwd = strEntryProp[7];
            }
            else
            {
                AppendMsg("Can not get Entry information! LogonID(" + 
                    iLogonID + ") Error(" + iRet + ")\r\n\r\n");
            }

            return iRet;
        }

        private int GetObsInfo(UInt32 iObsID,ref int iLogonID,
            ref int iChannel,ref int iStream, ref string strIP,
            ref string strProxyIP,ref string strID, ref int iMode,
            ref int iPort,ref string strUser, ref string strPwd,
            ref int iChannelNum, ref int iConnetStatus)
        {
            int iRet = GetObsInfo(iObsID, ref iLogonID, ref iChannel, 
                ref iStream, ref iMode, ref strIP);
            if (iRet == 0)
            {
                GetLogonInfo(iLogonID, ref strIP, ref strProxyIP, 
                    ref strID, ref iPort,ref strUser, ref strPwd, 
                    ref iChannelNum, ref iConnetStatus);
            }
            return iRet;
        }

        private int GetObsInfo(UInt32 iObsID, ref int iLogonID,
            ref int iChannel, ref int iStream,ref int iMode,
            ref string strIP)
        {
            string[] strRet = ocxPreview.Commander(Obs_Prop_Get, iObsID, 
                0, 0, 0, 0, 0, 0, 0, 0).Split('\n');
            int iRet = StrToInt(strRet[0]);
            if (iRet == 0)
            {
                string[] strObsProp = strRet[1].Split('\b');
                iLogonID = StrToInt(strObsProp[0]);
                if (iLogonID < 0)
                {
                    return -1;
                }
                strIP = strObsProp[1];
                iChannel = StrToInt(strObsProp[2]);
                iMode = StrToInt(strObsProp[3]);
                iStream = StrToInt(strObsProp[4]);
            }
            else
            {
                AppendMsg("Can not get information of Obs(" + iObsID + 
                    ")! Error(" + iRet + ")\r\n\r\n");
            }

            return iRet;
        }

        private void UpdateChannel(int iChannelNum)
        {
            if (cboChannel.Items.Count == iChannelNum)
            {
                return;
            }

            int iChannel = cboChannel.SelectedIndex;
            cboChannel.Items.Clear();
            for (int i = 0; i < iChannelNum; ++i)
            {
                cboChannel.Items.Add("CH" + (i + 1));
            }
            cboChannel.SelectedIndex = iChannel;
        }

        private void UpdateUI()
        {
            int iLogonID = -1,iChannel = 0,iStream = 0,iMode = 1,iPort = 3000,iChannelNum = 0,iConnetStatus = 0;
            string strIP = "",strProxyIP = "",strID = "",strUser = "",strPwd = "";
            if(GetObsInfo(ocxPreview.CurObs,ref iLogonID, ref iChannel, 
                ref iStream,ref strIP,ref strProxyIP, ref strID, 
                ref iMode,ref iPort, ref strUser, ref strPwd,
                ref iChannelNum, ref iConnetStatus) == 0)
            {
                m_iLogonID = iLogonID;
                UpdateChannel(iChannelNum);
                cboChannel.SelectedIndex = iChannel;
                cboStream.SelectedIndex = iStream;
                cboMode.SelectedIndex = iMode - 1;
                edtIP.Text = strIP;
                if (strProxyIP == "0.0.0.0")
                {
                    strProxyIP = "";
                }
                edtProxyIP.Text = strProxyIP;
                edtID.Text = strID;
                edtPort.Text = iPort.ToString();
                edtUser.Text = strUser;
                edtPwd.Text = strPwd;

                UInt16 uiBrightness = 0, uiHue = 0, uiContrast = 0, uiSaturation = 0;
                int iRet = GetVideoParam(iLogonID, iChannel,ref uiBrightness,
                    ref uiHue,ref uiContrast, ref uiSaturation);
                if (iRet == 0)
                {
                    trackBrightness.Value = uiBrightness;
                    trackHue.Value = uiHue;
                    trackSaturation.Value = uiSaturation;
                    trackContrast.Value = uiContrast;
                }

                int iCom = 0,iAddress = 0,iWorkMode = 0;
                string strProtocol = "",strComFormat = "";
                iRet = GetDeviceType(iLogonID, iChannel,ref strProtocol,
                    ref iWorkMode,ref strComFormat,ref iAddress, ref iCom);
                if (iRet == 0)
                {
                    cboComPort.SelectedIndex = iCom - 1;
                    cboProtocol.Text = strProtocol;
                    edtComFormat.Text = strComFormat;
                    edtDevAddress.Text = iAddress.ToString();
                    cboWorkMode.SelectedIndex = iWorkMode - 1;
                }

                UpdateProductName();
            }
        }

        private void btnDisconnect_Click(object sender, EventArgs e)
        {
            Disconnect(ocxPreview.CurObs);
        }

        private void btnCapPic_Click(object sender, EventArgs e)
        {
            CapturePicture();
        }

        private void btnRecordStop_Click(object sender, EventArgs e)
        {
            RecStop();
        }

        private void btnAudioStart_Click(object sender, EventArgs e)
        {
            AudioStart();
        }

        private void btnAudioStop_Click(object sender, EventArgs e)
        {
            AudioStop();
        }

        private void btnTalkStart_Click(object sender, EventArgs e)
        {
            TalkStart();
        }

        private void btnTalkStop_Click(object sender, EventArgs e)
        {
            TalkStop();
        }

        private void ocxSwallow_OnTalk(object sender, AxSwallowLib._DSwallowEvents_OnTalkEvent e)
        {
            AppendMsg("Talk Info:LogonID(" + e._LogonID + ") State(" + 
                e._State + ")\r\n\r\n");
        }

        private void ocxSwallow_OnRecErr(object sender, AxSwallowLib._DSwallowEvents_OnRecErrEvent e)
        {
            AppendMsg("Obs(" + e._ObsID + ") Record Error!\r\n\r\n");
        }

        private void ocxSwallow_OnError(object sender, AxSwallowLib._DSwallowEvents_OnErrorEvent e)
        {
            AppendMsg("Error: LogonID(" + e._ID + ") Type(" + 
                e._lType + ")!\r\n\r\n");
        }

        private void btnConfig_Click(object sender, EventArgs e)
        {
            ocxPreview.Commander(Entry_Config_Get, ocxPreview.CurObs, 
                0, 0, 0, 0, 0, 0, 0, 0);
        }

        private void trackBrightness_ValueChanged(object sender, EventArgs e)
        {
            lblBrightness.Text = trackBrightness.Value.ToString();
        }

        private void trackHue_ValueChanged(object sender, EventArgs e)
        {
            lblHue.Text = trackHue.Value.ToString();
        }

        private void trackContrast_ValueChanged(object sender, EventArgs e)
        {
            lblContrast.Text = trackContrast.Value.ToString();
        }

        private void trackSaturation_ValueChanged(object sender, EventArgs e)
        {
            lblSaturation.Text = trackSaturation.Value.ToString();
        }

        private int GetVideoParam(int iLogonID, int iChannel,
            ref UInt16 uiBrightness, ref UInt16 uiHue,
            ref UInt16 uiContrast, ref UInt16 uiSaturation)
        {
            string[] strRet = ocxPreview.Commander(Video_Display_Get, 
                iLogonID, iChannel, 0, 0, 0, 0, 0, 0, 0).Split('\n');
            int iRet = StrToInt(strRet[0]);
            if (iRet == 0)
            {
                string[] strVideoParam = strRet[1].Split('\b');
                uiBrightness = Convert.ToUInt16(strVideoParam[0]);
                uiContrast = Convert.ToUInt16(strVideoParam[1]);
                uiSaturation = Convert.ToUInt16(strVideoParam[2]);
                uiHue = Convert.ToUInt16(strVideoParam[3]);
            }
            else
            {
                AppendMsg("Get video param failed! LogonID(" + iLogonID + 
                    ") Channel(" + iChannel + ") Ret(" + iRet + ")\r\n\r\n");
            }
            return iRet;
        }

        private int SetVideoParam(int iLogonID, int iChannel,
            Int32 uiBrightness, Int32 uiHue,
            Int32 uiContrast, Int32 uiSaturation)
        {
            string[] strRet = ocxPreview.Commander(Video_Display_Set, 
                iLogonID, iChannel, uiBrightness, uiContrast,
                uiSaturation, uiHue, 0, 0, 0).Split('\n');
            int iRet = StrToInt(strRet[0]);
            if (iRet != 0)
            {
                AppendMsg("Set video param failed! LogonID(" + iLogonID + 
                    ") Channel(" + iChannel + ") Ret(" + iRet + ")\r\n\r\n");
            }
            return iRet;
        }

        private void UpdateVideoParam()
        {
            int iLogonID = -1, iChannel = 0, iStream = 0, iMode = 1;
            string strIP = "";
            int iRet = GetObsInfo(ocxPreview.CurObs, ref iLogonID,
                ref iChannel, ref iStream, ref iMode, ref strIP);
            if (iRet == 0 && iLogonID >= 0)
            {
                SetVideoParam(iLogonID, iChannel, trackBrightness.Value,
                    trackHue.Value, trackContrast.Value,
                    trackSaturation.Value);
            }
        }

        private void trackVideoParam_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Up || e.KeyCode == Keys.Down || 
                e.KeyCode == Keys.Left || e.KeyCode == Keys.Right)
            {
                UpdateVideoParam();
            }
        }

        private void trackVideoParam_MouseUp(object sender, MouseEventArgs e)
        {
            if(e.Button == MouseButtons.Left)
            {
                UpdateVideoParam();
            }
        }

        private int GetDeviceType(int iLogonID, int iChannel,
            ref string strProtocol, ref int iWorkMode, 
            ref string strComFormat, ref int iDevAddress, ref int iComPort)
        {
            string[] strRet = ocxPreview.Commander(Dev_DeviceType_Get, 
                iLogonID, iChannel, 0, 0, 0, 0, 0, 0, 0).Split('\n');
            int iRet = StrToInt(strRet[0]);
            if (iRet == 0)
            {
                string[] strDevType = strRet[1].Split('\b');
                iComPort = StrToInt(strDevType[0]);
                iDevAddress = StrToInt(strDevType[1]);
                strProtocol = strDevType[2];

                string[] strRetComFormat = ocxPreview.Commander(
                    Dev_SetComFormat_Get, iLogonID, iComPort, 
                    0, 0, 0, 0, 0, 0, 0).Split('\n');
                iRet = StrToInt(strRetComFormat[0]);
                if (iRet == 0)
                {
                    string[] strFormat = strRetComFormat[1].Split('\b');
                    strComFormat = strFormat[0];
                    iWorkMode = StrToInt(strFormat[1]);
                }
                else
                {
                    AppendMsg("Get Com Format Failed! LogonID(" + 
                        iLogonID + ") ComPort(" + iComPort + 
                        ") Ret(" + iRet + ")\r\n\r\n");
                }
            }
            else
            {
                AppendMsg("Get Dev Type Failed! LogonID(" + iLogonID + 
                    ") Channel(" + iChannel + ") Ret(" + iRet + ")\r\n\r\n");
            }
            return iRet;
        }

        private int SetDeviceType(int iLogonID, int iChannel,
            string strProtocol, int iWorkMode,
            string strComFormat, int iDevAddress, int iComPort)
        {
            string strRet = ocxPreview.Commander(Dev_DeviceType_Set, 
                iLogonID, iChannel, iComPort, iDevAddress,strProtocol, 
                0, 0, 0, 0);
            int iRet = StrToInt(strRet);
            if (iRet == 0)
            {
                strRet = ocxPreview.Commander(Dev_SetComFormat_Set, 
                    iLogonID, iComPort, strProtocol, strComFormat, 
                    iWorkMode, 0, 0, 0, 0);
                iRet = StrToInt(strRet);
                if (iRet != 0)
                {
                    AppendMsg("Set Com Format Failed! LogonID(" + 
                        iLogonID + ") ComPort(" + iComPort + 
                        ") Ret(" + iRet + ")\r\n\r\n");
                }
            }
            else
            {
                AppendMsg("Set Dev Type Failed! LogonID(" + iLogonID + 
                    ") Channel(" + iChannel + ") ComPort(" + iComPort + 
                    ") DevAddress(" + iDevAddress + ") Protocol(" + 
                    strProtocol + ") Ret(" + iRet + ")\r\n\r\n");
            }
            
            return iRet;
        }

        private void btnDeviceType_Click(object sender, EventArgs e)
        {
            int iLogonID = -1, iChannel = 0, iStream = 0, iMode = 0;
            string strIP = "";
            int iRet = GetObsInfo(ocxPreview.CurObs, ref iLogonID, 
                ref iChannel,ref iStream, ref iMode, ref strIP);
            if (iRet == 0 && iLogonID >= 0)
            {
                SetDeviceType(iLogonID, iChannel, cboProtocol.Text, 
                    cboWorkMode.SelectedIndex + 1, edtComFormat.Text, 
                    StrToInt(edtDevAddress.Text), 
                    cboComPort.SelectedIndex + 1);
            }
        }

        private void trackSpeed_ValueChanged(object sender, EventArgs e)
        {
            lblSpeed.Text = trackSpeed.Value.ToString();
        }

        private int ChannelControl(int iLogonID, int iChannel, int iDevAddress,
            int iAction, int iSpeed,int iPreset,int iComPort,
            string strProtocol)
        {
            string strRet = ocxPreview.Commander(Dev_Control_Cmd,iLogonID, iChannel, 
                iDevAddress, iAction,iSpeed, iPreset, iComPort, 
                strProtocol,0);
            int iRet = StrToInt(strRet);
            if (iRet != 0)
            {
                AppendMsg("Transparent Channel Control Failed! LogonID(" +
                    iLogonID+") Channel(" + iChannel+") Protocol(" + 
                    strProtocol +") Address(" + iDevAddress + 
                    ") ComPort(" + iComPort + ") Action(" + iAction +
                    ") Speed(" + iSpeed + ") Preset(" + iPreset + ") Ret(" + iRet + ")\r\n\r\n");
            }
            return iRet;
        }

        private int ProtocolControl(int iLogonID, int iChannel, 
            int iAction,int iSpeed, int iPreset, int iControlType)
        {
            int iParam1 = 0,iParam2 = 0;
            switch (iAction)
            {
                case MOVE_UP://向上移动
                    iAction = MOVE_UP_P;
                    iParam2 = iSpeed;
                    break;
                case MOVE_DOWN://向下移动
                    iAction = MOVE_DOWN_P;
                    iParam2 = -iSpeed;
                    break;
                case MOVE_LEFT://向左移动
                    iAction = MOVE_LEFT_P;
                    iParam1 = -iSpeed;
                    break;
                case MOVE_RIGHT://向右移动
                    iAction = MOVE_RIGHT_P;
                    iParam1 = iSpeed;
                    break;
                case MOVE_UP_LEFT://向左上移动
                    iAction = MOVE_UP_LEFT_P;
                    iParam1 = -iSpeed;
                    iParam2 = iSpeed;
                    break;
                case MOVE_UP_RIGHT://向右上移动
                    iAction = MOVE_UP_RIGHT_P;
                    iParam1 = iSpeed;
                    iParam2 = iSpeed;
                    break;
                case MOVE_DOWN_LEFT://向左下移动
                    iAction = MOVE_DOWN_LEFT_P;
                    iParam1 = -iSpeed;
                    iParam2 = -iSpeed;
                    break;
                case MOVE_DOWN_RIGHT://向右下移动
                    iAction = MOVE_DOWN_RIGHT_P;
                    iParam1 = iSpeed;
                    iParam2 = -iSpeed;
                    break;
                case ZOOM_BIG://变倍大
                    iAction = ZOOM_BIG_P;
                    iParam1 = iSpeed;
                    iParam2 = iSpeed;
                    break;
                case ZOOM_SMALL://变倍小
                    iAction = ZOOM_SMALL_P;
                    iParam1 = iSpeed;
                    iParam2 = iSpeed;
                    break;
                case FOCUS_NEAR://聚焦近
                    iAction = FOCUS_NEAR_P;
                    iParam1 = iSpeed;
                    iParam2 = iSpeed;
                    break;
                case FOCUS_FAR://聚焦远
                    iAction = FOCUS_FAR_P;
                    iParam1 = iSpeed;
                    iParam2 = iSpeed;
                    break;
                case IRIS_OPEN://光圈开
                    iAction = IRIS_OPEN_P;
                    iParam1 = iSpeed;
                    iParam2 = iSpeed;
                    break;
                case IRIS_CLOSE://光圈关
                    iAction = IRIS_CLOSE_P;
                    iParam1 = iSpeed;
                    iParam2 = iSpeed;
                    break;
                case RAIN_ON://雨刷开
                    iAction = RAIN_ON_P;
                    iParam1 = iSpeed;
                    iParam2 = iSpeed;
                    break;
                case RAIN_OFF: //雨刷关
                    iAction = RAIN_OFF_P;
                    iParam1 = iSpeed;
                    iParam2 = iSpeed;
                    break;
                case LIGHT_ON://灯光开
                    iAction = LIGHT_ON_P;
                    iParam1 = iSpeed;
                    iParam2 = iSpeed;
                    break;
                case LIGHT_OFF://灯光关
                    iAction = LIGHT_OFF_P;
                    iParam1 = iSpeed;
                    iParam2 = iSpeed;
                    break;
                case HOR_AUTO://水平自动
                    iAction = HOR_AUTO_P;
                    break;
                case HOR_AUTO_STOP://停止水平自动
                    iAction = HOR_AUTO_STOP_P;
                    break;
                case CALL_VIEW://调用预置位
                    iAction = CALL_VIEW_P;
                    iParam1 = iPreset;
                    break;
                case SET_VIEW://设置预置位
                    iAction = SET_VIEW_P;
                    iParam1 = iPreset;
                    break;
                case POWER_ON://电源开
                    iAction = POWER_ON_P;
                    iParam1 = iSpeed;
                    iParam2 = iSpeed;
                    break;
                case POWER_OFF://电源关
                    iAction = POWER_OFF_P;
                    iParam1 = iSpeed;
                    iParam2 = iSpeed;
                    break;
                default:
                    iAction = MOVE_STOP_P;
                    break;
            }

            string strRet = ocxPreview.Commander(Dev_Device_Ctrl, iLogonID,
                iChannel,iAction,iParam1,iParam2,iControlType,0,0,0);
            int iRet = StrToInt(strRet);
            if (iRet != 0)
            {
                AppendMsg("Protocol Control Failed! LogonID(" + iLogonID + 
                    ") Channel(" + iChannel + ") Action(" + iAction +
                    ") Param1(" + iParam1 + ") Param2(" + iParam2 +
                    ") ControlType(" + iControlType + ") Ret(" + iRet + ")\r\n\r\n");
            }
            return iRet;
        }

        private int DeviceControl(int iAction)
        {
            int iLogonID = -1, iChannel = 0, iStream = 0, iMode = 0;
            string strIP = "";
            int iRet = GetObsInfo(ocxPreview.CurObs, ref iLogonID,
                ref iChannel, ref iStream, ref iMode, ref strIP);
            if (iRet == 0 && iLogonID >= 0)
            {
                int iWorkMode = cboWorkMode.SelectedIndex + 1; 
                int iSpeed = trackSpeed.Value;
                int iPreset = StrToInt(edtPreset.Text);
                if (iAction == CALL_VIEW || iAction == SET_VIEW)
                {
                    if (iPreset < 1 || iPreset > 255)
                    {
                        MessageBox.Show("Please input a validate preset!");
                        return -1;
                    }
                }
                if (iWorkMode == 1)//协议
                {
                    //电子云台的参数,控制类型(Normal,e_PTZ)
                    int iControlType = chkPTZ.Checked == true ? 1 : 0;
                    return ProtocolControl(iLogonID, iChannel, iAction, 
                        iSpeed,iPreset,iControlType);
                }
                else//透明通道
                {
                    int iDevAddress = StrToInt(edtDevAddress.Text);
                    int iComPort = cboComPort.SelectedIndex + 1;
                    string strProtocol = cboProtocol.Text;
                    return ChannelControl(iLogonID, iChannel,iDevAddress, 
                        iAction,iSpeed, iPreset, iComPort,strProtocol);
                }
            }
            return -1;
        }

        

        private void btnPtzCtrl_MouseDown(object sender, MouseEventArgs e)
        {
            Button btnAction = (Button)sender;

            //获得Tag属性中的控制码
            int iAction = Convert.ToInt32((StrToInt(btnAction.Tag.ToString()) & 0xFFFF0000) >> 16);
            DeviceControl(iAction);
        }

        private void btnPtzCtrl_MouseUp(object sender, MouseEventArgs e)
        {
            Button btnAction = (Button)sender;

            //获得Tag属性中的控制码
            int iAction = (StrToInt(btnAction.Tag.ToString()) & 0xFFFF);
            DeviceControl(iAction);
        }

        private void btnMoveAuto_Click(object sender, EventArgs e)
        {
            if (btnMoveAuto.Text == "Auto")
            {
                if(DeviceControl(HOR_AUTO) == 0)
                {
                    btnMoveAuto.Text = "Stop";
                }
            }
            else
            {
                if(DeviceControl(HOR_AUTO_STOP) == 0)
                {
                    btnMoveAuto.Text = "Auto";
                }
            }
        }

        private void btnPtzCtrl_Click(object sender, EventArgs e)
        {
            Button btnAction = (Button)sender;
            int iAction = StrToInt(btnAction.Tag.ToString());
            DeviceControl(iAction);
        }

        private void chkPtzCtrl_Click(object sender, EventArgs e)
        {
            CheckBox chkAction = (CheckBox)sender;
            int iAction = StrToInt(chkAction.Tag.ToString());

            if (chkAction.Checked)
            {
                if (DeviceControl(Convert.ToInt32((iAction & 0xFFFF0000) >> 16)) != 0)
                {
                    chkAction.Checked = false;
                }
            }
            else
            {
                if (DeviceControl(Convert.ToInt32(iAction & 0xFFFF)) != 0)
                {
                    chkAction.Checked = true;
                }
            }
        }

        private void btnQuery_Click(object sender, EventArgs e)
        {
            int iPort = 3000, iChannelNum = 0, iConnetStatus = 0;
                string strIP = "", strProxyIP = "", strID = "", strUser = "", strPwd = "";
            int iRet = GetLogonInfo(m_iLogonID,ref strIP,ref strProxyIP,
                    ref strID,ref iPort,ref strUser,ref strPwd,
                    ref iChannelNum,ref iConnetStatus);
            if (iRet != 0)
            {
                return;
            }
            
            try
            {
                PlayBack playBack = new PlayBack();
                playBack.LogonID = m_iLogonID;
                playBack.ChannelNum = iChannelNum;
                playBack.IPAddress = strIP;
                playBack.ShowDialog();
            }
            catch (System.Exception /*ex*/)
            {
            	
            }
        }

        int StrToInt(string strData)
        {
            int iData = 0;
            try
            {
                iData = Convert.ToInt32(strData);
            }
            catch (System.Exception /*ex*/)
            {
                iData = 0;
            }
            return iData;
        }

        private void ocxPreview_OnConnectDecrypt(object sender, AxSwallowLib._DSwallowEvents_OnConnectDecryptEvent e)
        {
            switch (e._lNotifyType)
            {
                case WCM_NEED_DECRYPT_KEY:
                    AppendMsg("Need decrypt key! LogonID(" + e._lLogonID + ") Channel(" + e._ulChannel + ") \r\n\r\n");
                    break;
                case WCM_DECRYPT_KEY_FAILED:
                    AppendMsg("Decrypt failed! LogonID(" + e._lLogonID + ") Channel(" + e._ulChannel + ") \r\n\r\n");
                    break;
                case WCM_DECRYPT_SUCCESS:
                    AppendMsg("Decrypt success! LogonID(" + e._lLogonID + ") Channel(" + e._ulChannel + ") \r\n\r\n");
                    break;
                default:
                    break;
            }
            
        }

        private void btnDecrypt_Click(object sender, EventArgs e)
        {
            int iLogonID = -1, iChannel = 0, iStream = 0, iMode = 1;
            string strIP = "";
            int iRet = GetObsInfo(ocxPreview.CurObs, ref iLogonID,
                ref iChannel, ref iStream, ref iMode, ref strIP);
            if (iRet == 0 && iLogonID >= 0)
            {
                string strKey = edtDecrypt.Text;
                string strRet = ocxPreview.Commander(DEVICE_DECRYPT_SET, iLogonID,
                   iChannel, strKey, strKey.Length, 0, 0, 0, 0, 0);
                iRet = StrToInt(strRet);
                if (iRet != 0)
                {
                    AppendMsg("Decrypt failed! LogonID(" + iLogonID +
                        ") Channel(" + iChannel + ") DecryptKey(" +
                        strKey + ") Ret(" + iRet + ")\r\n\r\n");
                }
            }
        }
    }
}
